# coding: utf-8

"""
    EVR API

    OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

    The version of the OpenAPI document: 1.14.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictStr, conint

from typing import Optional

from pyevr.openapi_client.models.paged_result_of_place_of_delivery import (
    PagedResultOfPlaceOfDelivery,
)
from pyevr.openapi_client.models.place_of_delivery import PlaceOfDelivery
from pyevr.openapi_client.models.put_place_of_delivery_request import (
    PutPlaceOfDeliveryRequest,
)

from pyevr.openapi_client.api_client import ApiClient
from pyevr.openapi_client.api_response import ApiResponse
from pyevr.openapi_client.exceptions import ApiTypeError, ApiValueError  # noqa: F401


class PlaceOfDeliveriesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def place_of_deliveries_add_or_update(
        self,
        code: Annotated[StrictStr, Field(..., description="Kood")],
        put_place_of_delivery_request: PutPlaceOfDeliveryRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        **kwargs
    ) -> None:  # noqa: E501
        """Tarnekoha lisamine ja muutmine  # noqa: E501

        Lisab uue tarnekoha. Kui antud koodiga tarnekoht juba eksisteerib, siis muudab olemasolevat tarnekohta. Loomisel märgitakse päringu tegija tarnekoha omanikuks.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.place_of_deliveries_add_or_update(code, put_place_of_delivery_request, evr_language, async_req=True)
        >>> result = thread.get()

        :param code: Kood (required)
        :type code: str
        :param put_place_of_delivery_request: (required)
        :type put_place_of_delivery_request: PutPlaceOfDeliveryRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the place_of_deliveries_add_or_update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.place_of_deliveries_add_or_update_with_http_info(
            code, put_place_of_delivery_request, evr_language, **kwargs
        )  # noqa: E501

    @validate_arguments
    def place_of_deliveries_add_or_update_with_http_info(
        self,
        code: Annotated[StrictStr, Field(..., description="Kood")],
        put_place_of_delivery_request: PutPlaceOfDeliveryRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        **kwargs
    ) -> ApiResponse:  # noqa: E501
        """Tarnekoha lisamine ja muutmine  # noqa: E501

        Lisab uue tarnekoha. Kui antud koodiga tarnekoht juba eksisteerib, siis muudab olemasolevat tarnekohta. Loomisel märgitakse päringu tegija tarnekoha omanikuks.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.place_of_deliveries_add_or_update_with_http_info(code, put_place_of_delivery_request, evr_language, async_req=True)
        >>> result = thread.get()

        :param code: Kood (required)
        :type code: str
        :param put_place_of_delivery_request: (required)
        :type put_place_of_delivery_request: PutPlaceOfDeliveryRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = ["code", "put_place_of_delivery_request", "evr_language"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method place_of_deliveries_add_or_update" % _key
                )
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params["code"]:
            _path_params["code"] = _params["code"]

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        if _params["evr_language"]:
            _header_params["EVR-LANGUAGE"] = _params["evr_language"]

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params["put_place_of_delivery_request"] is not None:
            _body_params = _params["put_place_of_delivery_request"]

        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get(
            "_content_type",
            self.api_client.select_header_content_type(["application/json"]),
        )
        if _content_types_list:
            _header_params["Content-Type"] = _content_types_list

        # authentication setting
        _auth_settings = ["SecretApiKey"]  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            "/api/placeofdeliveries/{code}",
            "PUT",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )

    @validate_arguments
    def place_of_deliveries_get(
        self,
        code: Annotated[
            StrictStr, Field(..., description="Päritava tarnekoha kood (tõstutundlik)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        **kwargs
    ) -> PlaceOfDelivery:  # noqa: E501
        """Tarnekoha pärimine  # noqa: E501

        Tagastab koodile vastava tarnekoha. Pärida saab ainult enda asutusele kuuluvat tarnekohta.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.place_of_deliveries_get(code, evr_language, async_req=True)
        >>> result = thread.get()

        :param code: Päritava tarnekoha kood (tõstutundlik) (required)
        :type code: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PlaceOfDelivery
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the place_of_deliveries_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.place_of_deliveries_get_with_http_info(
            code, evr_language, **kwargs
        )  # noqa: E501

    @validate_arguments
    def place_of_deliveries_get_with_http_info(
        self,
        code: Annotated[
            StrictStr, Field(..., description="Päritava tarnekoha kood (tõstutundlik)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        **kwargs
    ) -> ApiResponse:  # noqa: E501
        """Tarnekoha pärimine  # noqa: E501

        Tagastab koodile vastava tarnekoha. Pärida saab ainult enda asutusele kuuluvat tarnekohta.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.place_of_deliveries_get_with_http_info(code, evr_language, async_req=True)
        >>> result = thread.get()

        :param code: Päritava tarnekoha kood (tõstutundlik) (required)
        :type code: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PlaceOfDelivery, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = ["code", "evr_language"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method place_of_deliveries_get" % _key
                )
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params["code"]:
            _path_params["code"] = _params["code"]

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        if _params["evr_language"]:
            _header_params["EVR-LANGUAGE"] = _params["evr_language"]

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # authentication setting
        _auth_settings = ["SecretApiKey"]  # noqa: E501

        _response_types_map = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "PlaceOfDelivery",
        }

        return self.api_client.call_api(
            "/api/placeofdeliveries/{code}",
            "GET",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )

    @validate_arguments
    def place_of_deliveries_list(
        self,
        name_contains: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit"
            ),
        ] = None,
        code_starts_with: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)"
            ),
        ] = None,
        register_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile"
            ),
        ] = None,
        address: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS"
            ),
        ] = None,
        page: Annotated[
            Optional[conint(strict=True, le=2147483647, ge=1)],
            Field(description="Tagastatav lehekülg"),
        ] = None,
        page_size: Annotated[
            Optional[conint(strict=True, le=500, ge=1)],
            Field(description="Tagastatava lehekülje suurus"),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        **kwargs
    ) -> PagedResultOfPlaceOfDelivery:  # noqa: E501
        """Tarnekohtade pärimine  # noqa: E501

        Tagastab filtritele vastavad aktiivsed avalikud tarnekohad ja kõik ettevõttega seotud tarnekohad.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.place_of_deliveries_list(name_contains, code_starts_with, register_code, address, page, page_size, evr_language, async_req=True)
        >>> result = thread.get()

        :param name_contains: Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit
        :type name_contains: str
        :param code_starts_with: Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)
        :type code_starts_with: str
        :param register_code: Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile
        :type register_code: str
        :param address: Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS
        :type address: str
        :param page: Tagastatav lehekülg
        :type page: int
        :param page_size: Tagastatava lehekülje suurus
        :type page_size: int
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PagedResultOfPlaceOfDelivery
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the place_of_deliveries_list_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.place_of_deliveries_list_with_http_info(
            name_contains,
            code_starts_with,
            register_code,
            address,
            page,
            page_size,
            evr_language,
            **kwargs
        )  # noqa: E501

    @validate_arguments
    def place_of_deliveries_list_with_http_info(
        self,
        name_contains: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit"
            ),
        ] = None,
        code_starts_with: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)"
            ),
        ] = None,
        register_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile"
            ),
        ] = None,
        address: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS"
            ),
        ] = None,
        page: Annotated[
            Optional[conint(strict=True, le=2147483647, ge=1)],
            Field(description="Tagastatav lehekülg"),
        ] = None,
        page_size: Annotated[
            Optional[conint(strict=True, le=500, ge=1)],
            Field(description="Tagastatava lehekülje suurus"),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        **kwargs
    ) -> ApiResponse:  # noqa: E501
        """Tarnekohtade pärimine  # noqa: E501

        Tagastab filtritele vastavad aktiivsed avalikud tarnekohad ja kõik ettevõttega seotud tarnekohad.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.place_of_deliveries_list_with_http_info(name_contains, code_starts_with, register_code, address, page, page_size, evr_language, async_req=True)
        >>> result = thread.get()

        :param name_contains: Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit
        :type name_contains: str
        :param code_starts_with: Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)
        :type code_starts_with: str
        :param register_code: Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile
        :type register_code: str
        :param address: Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS
        :type address: str
        :param page: Tagastatav lehekülg
        :type page: int
        :param page_size: Tagastatava lehekülje suurus
        :type page_size: int
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PagedResultOfPlaceOfDelivery, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            "name_contains",
            "code_starts_with",
            "register_code",
            "address",
            "page",
            "page_size",
            "evr_language",
        ]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method place_of_deliveries_list" % _key
                )
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get("name_contains") is not None:  # noqa: E501
            _query_params.append(("name_contains", _params["name_contains"]))

        if _params.get("code_starts_with") is not None:  # noqa: E501
            _query_params.append(("code_starts_with", _params["code_starts_with"]))

        if _params.get("register_code") is not None:  # noqa: E501
            _query_params.append(("register_code", _params["register_code"]))

        if _params.get("address") is not None:  # noqa: E501
            _query_params.append(("address", _params["address"]))

        if _params.get("page") is not None:  # noqa: E501
            _query_params.append(("page", _params["page"]))

        if _params.get("page_size") is not None:  # noqa: E501
            _query_params.append(("page_size", _params["page_size"]))

        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        if _params["evr_language"]:
            _header_params["EVR-LANGUAGE"] = _params["evr_language"]

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # authentication setting
        _auth_settings = ["SecretApiKey"]  # noqa: E501

        _response_types_map = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "400": "ValidationResult",
            "200": "PagedResultOfPlaceOfDelivery",
        }

        return self.api_client.call_api(
            "/api/placeofdeliveries",
            "GET",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )
