# coding: utf-8

"""
    EVR API

    OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

    The version of the OpenAPI document: 1.14.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist
from pyevr.openapi_client.models.shipment import Shipment


class AddShipmentsToWaybillRequest(BaseModel):
    """
    AddShipmentsToWaybillRequest
    """

    shipments: conlist(Shipment, max_items=25, min_items=1) = Field(
        ..., description="Lisatavad veose andmed"
    )
    __properties = ["shipments"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AddShipmentsToWaybillRequest:
        """Create an instance of AddShipmentsToWaybillRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in shipments (list)
        _items = []
        if self.shipments:
            for _item in self.shipments:
                if _item:
                    _items.append(_item.to_dict())
            _dict["shipments"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AddShipmentsToWaybillRequest:
        """Create an instance of AddShipmentsToWaybillRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AddShipmentsToWaybillRequest.parse_obj(obj)

        _obj = AddShipmentsToWaybillRequest.parse_obj(
            {
                "shipments": [
                    Shipment.from_dict(_item) for _item in obj.get("shipments")
                ]
                if obj.get("shipments") is not None
                else None
            }
        )
        return _obj
