# coding: utf-8

"""
    EVR API

    OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

    The version of the OpenAPI document: 1.14.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, confloat, conint
from pyevr.openapi_client.models.pack_location import PackLocation


class Pack(BaseModel):
    """
    Pack
    """

    pack_number: conint(strict=True, le=2147483647, ge=1) = Field(
        ..., alias="packNumber", description="Paki number"
    )
    length: Union[
        confloat(le=1.0e9, ge=0.0, strict=True),
        conint(le=1000000000, ge=0, strict=True),
    ] = Field(..., description="Koormapaki pikkus")
    height: Union[
        confloat(le=1.0e9, ge=0.0, strict=True),
        conint(le=1000000000, ge=0, strict=True),
    ] = Field(..., description="Koosmapaki kõrgus")
    width: Union[
        confloat(le=1.0e9, ge=0.0, strict=True),
        conint(le=1000000000, ge=0, strict=True),
    ] = Field(..., description="Koormapaki laius")
    coefficient: Union[
        confloat(le=1.0, ge=0.0, strict=True), conint(le=1, ge=0, strict=True)
    ] = Field(..., description="Koeffitsient")
    location: PackLocation = Field(...)
    __properties = [
        "packNumber",
        "length",
        "height",
        "width",
        "coefficient",
        "location",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Pack:
        """Create an instance of Pack from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Pack:
        """Create an instance of Pack from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Pack.parse_obj(obj)

        _obj = Pack.parse_obj(
            {
                "pack_number": obj.get("packNumber"),
                "length": obj.get("length"),
                "height": obj.get("height"),
                "width": obj.get("width"),
                "coefficient": obj.get("coefficient"),
                "location": obj.get("location"),
            }
        )
        return _obj
