# coding: utf-8

"""
    EVR API

    OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

    The version of the OpenAPI document: 1.14.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from pydantic import BaseModel, Field, constr


class ShipmentAssortment(BaseModel):
    """
    ShipmentAssortment
    """

    code: constr(strict=True, max_length=10, min_length=0) = Field(
        ...,
        description="Sortimendi kood. Kui organisatsioon on seadistatud kasutama EVR sortimente, peab kood olema [üks EVR sortimentide koodist.](#operation/Assortments_List)",
    )
    name: constr(strict=True, max_length=100, min_length=0) = Field(
        ..., description="Sortimendi nimetus"
    )
    product_group: constr(strict=True, max_length=10, min_length=0) = Field(
        ..., alias="productGroup", description="Tootegrupi kood"
    )
    __properties = ["code", "name", "productGroup"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ShipmentAssortment:
        """Create an instance of ShipmentAssortment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ShipmentAssortment:
        """Create an instance of ShipmentAssortment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ShipmentAssortment.parse_obj(obj)

        _obj = ShipmentAssortment.parse_obj(
            {
                "code": obj.get("code"),
                "name": obj.get("name"),
                "product_group": obj.get("productGroup"),
            }
        )
        return _obj
